#include "FastLED.h"

#define DATA_PIN_A 14  // 15 WS2812B LEDs
#define DATA_PIN_B 15  //  7 SK6812-MINI-E LEDs (switch backlights)

#define LED_TYPE_A WS2812B
#define COLOR_ORDER_A GRB
#define BRIGHTNESS 64
#define LED_TYPE_B WS2812B //SK6812-MINI-E LEDs control like WS2812B LEDs
#define COLOR_ORDER_B GRB
#define BRIGHTNESS 64

#define NUM_LEDS_A 15  
#define NUM_LEDS_B 7

CRGB ledsA[NUM_LEDS_A];
CRGB ledsB[NUM_LEDS_B];

#define buzzer 10  // speaker is on pin 10

int C  = 4;
int D  = 5;
int E  = 6;
int F  = 7;
int G  = 8;
int A  = 3;
int B  = 2;

int c  = 262;
int d  = 294;
int e  = 330;
int f  = 349;
int g  = 392;
int a  = 440;
int b  = 494;

void setup() {
  Serial.begin(9600);
  pinMode(C, INPUT_PULLUP);
  pinMode(D, INPUT_PULLUP);
  pinMode(E, INPUT_PULLUP);
  pinMode(F, INPUT_PULLUP);
  pinMode(G, INPUT_PULLUP);
  pinMode(A, INPUT_PULLUP);
  pinMode(B, INPUT_PULLUP);
  pinMode(buzzer, OUTPUT);
  FastLED.addLeds<LED_TYPE_A, DATA_PIN_A, COLOR_ORDER_A>(ledsA, NUM_LEDS_A);
  FastLED.addLeds<LED_TYPE_B, DATA_PIN_B, COLOR_ORDER_B>(ledsB, NUM_LEDS_B);
  FastLED.setBrightness(BRIGHTNESS);
  LEDaCycle();
}

void LEDaCycle() {
  FastLED.clear();
  for (int hue=0; hue<400; hue+=50) {
     fill_rainbow(ledsA, NUM_LEDS_A, hue, 7);
     FastLED.show();
     delay(40);
  }
}

void loop() {
  #define dt 150
  
  if (!digitalRead(C)) {
    ledsB[6] = CRGB::Red;
    FastLED.show();
    Serial.println("C");
    tone(buzzer, c);
    delay(dt);
    ledsB[6] = CRGB::Black;
    FastLED.show();
    LEDaCycle();
  }
 
  if (!digitalRead(D)) {
    ledsB[5] = CRGB::Blue;
    FastLED.show();
    Serial.println("D");
    tone(buzzer, d);
    delay(dt);
    ledsB[5] = CRGB::Black;
    FastLED.show();
    LEDaCycle();
  }

  if (!digitalRead(E)) {
    ledsB[4] = CRGB::Yellow;
    FastLED.show();
    Serial.println("E");
    tone(buzzer, e);
    delay(dt);
    ledsB[4] = CRGB::Black;
    FastLED.show();
    LEDaCycle();
  }

  if (!digitalRead(F)) {
    ledsB[3] = CRGB::Orange;
    FastLED.show();
    Serial.println("F");
    tone(buzzer, f);
    delay(dt);
    ledsB[3] = CRGB::Black;
    FastLED.show();
    LEDaCycle();
  }

  if (!digitalRead(G)) {
    ledsB[2] = CRGB::Blue;
    FastLED.show();
    Serial.println("G");
    tone(buzzer, g);
    delay(dt);
    ledsB[2] = CRGB::Black;
    FastLED.show();
    LEDaCycle();
  }

  if (!digitalRead(A)) {
    ledsB[1] = CRGB::Red;
    FastLED.show();
    Serial.println("A");
    tone(buzzer, a);
    delay(dt);
    ledsB[1] = CRGB::Black;
    FastLED.show();
    LEDaCycle();
  }

  if (!digitalRead(B)) {
    ledsB[0] = CRGB::Green;
    FastLED.show();
    Serial.println("B");
    tone(buzzer, b);
    delay(dt);
    ledsB[0] = CRGB::Black;
    FastLED.show();
    LEDaCycle();
  }
  
  noTone(buzzer);
}
